<?xml version="1.0" encoding="utf-8" ?>
<ContentPage xmlns="http://schemas.microsoft.com/dotnet/2021/maui"
			  xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
			  x:Class="KieselsteinErp.Terminal.Views.BookMaterialPage"
			  xmlns:toolkit="http://schemas.microsoft.com/dotnet/2022/maui/toolkit"
			  xmlns:controls="clr-namespace:KieselsteinErp.Terminal.Controls"
			  xmlns:templates="clr-namespace:KieselsteinErp.Terminal.Resources.Templates"
			  xmlns:localization="clr-namespace:LocalizationResourceManager.Maui;assembly=LocalizationResourceManager.Maui"
			  xmlns:models="clr-namespace:KieselsteinErp.Terminal.Models"
			  xmlns:viewmodels="clr-namespace:KieselsteinErp.Terminal.ViewModels"
			  Title="{Binding Title}">

  <ContentPage.Resources>
    <ResourceDictionary>
      <toolkit:InvertedBoolConverter x:Key="InvertedBoolConverter" />
      <toolkit:EnumToBoolConverter x:Key="SerialChargeNrConverter">
        <toolkit:EnumToBoolConverter.TrueValues>
        </toolkit:EnumToBoolConverter.TrueValues>
      </toolkit:EnumToBoolConverter>
      <!--Both templates should be the same appart from the Backgroundcolor. Always change both.-->
      <DataTemplate x:Key="EvenTemplate" x:DataType="{x:Type models:BookingMaterial}">
        <controls:ViewCellEx>
          <Grid Style="{StaticResource TableEven}" ColumnDefinitions="0.5*,2*,3*,5*,0.5*,*,*,0.1*,1.5*" RowDefinitions="*" Padding="5">
            <Grid.GestureRecognizers>
              <TapGestureRecognizer Command="{Binding Source={RelativeSource AncestorType={x:Type viewmodels:BookMaterialPageViewModel}}, Path=FrameTappedCommand}" CommandParameter="{Binding .}" NumberOfTapsRequired="2" />
            </Grid.GestureRecognizers>
            <Label Grid.Column="0" Text="{Binding Type}" VerticalOptions="Center" />
            <Label Grid.Column="1" Text="{Binding Cnr}" VerticalOptions="Center" />
            <Label Grid.Column="2" Text="{Binding Name}" VerticalOptions="Center" />
            <Label Grid.Column="3" Text="{Binding Description}" VerticalOptions="Center" IsVisible="{Binding BookingError, Converter={StaticResource InvertedBoolConverter}}"/>
            <Label Grid.Column="3" Text="{Binding ErrorMsg}" TextColor="{AppThemeBinding Light={StaticResource light_error},Dark={StaticResource dark_error}}" VerticalOptions="Center" IsVisible="{Binding BookingError}"/>
            <Label Grid.Column="4" Text="{Binding Unit}" VerticalOptions="Center" />
            <Label Grid.Column="5" Text="{Binding Amount, StringFormat='{0:F3}'}" VerticalOptions="Center" HorizontalOptions="End" />
            <Label Grid.Column="6" Text="{Binding AmountIssued, StringFormat='{0:F3}'}" VerticalOptions="Center" HorizontalOptions="End" />
            <Grid Grid.Column="8" BackgroundColor="Transparent" Padding="0" RowDefinitions="*" ColumnDefinitions="*">
              <controls:NumericEntry Grid.Column="8"  Placeholder="Enter Amount" Text="{Binding WithdrawalAmount}" VerticalTextAlignment="End" DecimalPlaces="3" VerticalOptions="Center"
															IsEnabled="{Binding SerialChargeNr, Converter={StaticResource SerialChargeNrConverter}, ConverterParameter={x:Static models:SerialChargeNr.None}}" >
              </controls:NumericEntry>
            </Grid>
          </Grid>
        </controls:ViewCellEx>
      </DataTemplate>

      <DataTemplate x:Key="OddTemplate" x:DataType="{x:Type models:BookingMaterial}">
        <controls:ViewCellEx>
          <Grid Style="{StaticResource TableOdd}" ColumnDefinitions="0.5*,2*,3*,5*,0.5*,*,*,0.1*,1.5*" RowDefinitions="*" Padding="5" >
            <Grid.GestureRecognizers>
              <TapGestureRecognizer Command="{Binding Source={RelativeSource AncestorType={x:Type viewmodels:BookMaterialPageViewModel}}, Path=FrameTappedCommand}" CommandParameter="{Binding .}" NumberOfTapsRequired="2" />
            </Grid.GestureRecognizers>
            <Label Grid.Column="0" Text="{Binding Type}" VerticalOptions="Center" />
            <Label Grid.Column="1" Text="{Binding Cnr}" VerticalOptions="Center" />
            <Label Grid.Column="2" Text="{Binding Name}" VerticalOptions="Center" />
            <Label Grid.Column="3" Text="{Binding Description}" VerticalOptions="Center" IsVisible="{Binding BookingError, Converter={StaticResource InvertedBoolConverter}}"/>
            <Label Grid.Column="3" Text="{Binding ErrorMsg}" TextColor="{AppThemeBinding Light={StaticResource light_error},Dark={StaticResource dark_error}}" VerticalOptions="Center" IsVisible="{Binding BookingError}"/>
            <Label Grid.Column="4" Text="{Binding Unit}" VerticalOptions="Center" />
            <Label Grid.Column="5" Text="{Binding Amount, StringFormat='{0:F3}'}" VerticalOptions="Center" HorizontalOptions="End" />
            <Label Grid.Column="6" Text="{Binding AmountIssued, StringFormat='{0:F3}'}" VerticalOptions="Center" HorizontalOptions="End" />
            <Grid Grid.Column="8" BackgroundColor="Transparent" Padding="0" RowDefinitions="*" ColumnDefinitions="*">
              <controls:NumericEntry Grid.Column="8" Placeholder="Enter Amount" Text="{Binding WithdrawalAmount}" VerticalTextAlignment="End" DecimalPlaces="3" VerticalOptions="Center"
												  IsEnabled="{Binding SerialChargeNr, Converter={StaticResource SerialChargeNrConverter}, ConverterParameter={x:Static models:SerialChargeNr.None}}" >
              </controls:NumericEntry>
            </Grid>
          </Grid>
        </controls:ViewCellEx>
      </DataTemplate>

      <templates:AlternatingItemTemplateSelector x:Key="AlternatingTemplateSelector"
                                                   EvenTemplate="{StaticResource EvenTemplate}"
                                                   OddTemplate="{StaticResource OddTemplate}" />
    </ResourceDictionary>
  </ContentPage.Resources>


  <Grid Padding="0" RowDefinitions="Auto, *, Auto" Margin="5" BackgroundColor="{AppThemeBinding Light={StaticResource White}, Dark={StaticResource Black}}">
    <Border Style="{StaticResource TableFrame}" Grid.Row="1" >
      <Grid RowDefinitions="Auto,*">
        <Border Style="{StaticResource PopupTitle}" Padding="5">
          <Grid ColumnDefinitions="0.5*,2*,3*,5*,0.5*,*,*,0.1*,1.5*" >
            <Label Grid.Column="0"
						 Text="Type"  HorizontalOptions="Center" LineBreakMode="TailTruncation"/>
            <Label Grid.Column="1"
						 Text="{localization:Translate ItemNo}"  HorizontalOptions="Center" />
            <Label Grid.Column="2"
						 Text="{localization:Translate Name}"  HorizontalOptions="Center" />
            <Label Grid.Column="3"
						 Text="{localization:Translate Description}"  HorizontalOptions="Center" />
            <Label Grid.Column="5"
						 Text="{localization:Translate Amount}"  HorizontalOptions="Center" />
            <Label Grid.Column="6"
						 Text="{localization:Translate Issued}"  HorizontalOptions="Center" LineBreakMode="TailTruncation" />
            <Label Grid.Column="8"
						 Text="{localization:Translate Withdrawal}"  HorizontalOptions="Center" />
          </Grid>
        </Border>

        <!--<ScrollView >-->
        <ListView Grid.Row="1" x:Name="Collection" ItemsSource="{Binding BookingMaterials}"	ItemTemplate="{StaticResource AlternatingTemplateSelector}" HasUnevenRows="True"/>
        <!--</ScrollView>-->
      </Grid>
    </Border>
    <VerticalStackLayout Grid.Row="2" HorizontalOptions="Center" VerticalOptions="End">
      <BoxView MinimumHeightRequest="5" BackgroundColor="Transparent" Color="Transparent"/>
      <HorizontalStackLayout  Spacing="40" >
        <Button Text="{localization:Translate Ok}" MinimumWidthRequest="180" Command="{Binding OkCommand}"/>
        <Button Text="{localization:Translate Cancel}" MinimumWidthRequest="180" Command="{Binding CancelCommand}"/>
      </HorizontalStackLayout>
    </VerticalStackLayout>
  </Grid>

</ContentPage>